; Dibuja una polilinea reemplazando todos los segmentos de arcos en segmentos lineales de acuerdo a una distania especificada.

;|Este es un lisp en formato original, se puede ver el cdigo fuente, la intencin, es de que el cdigo fuente 
; pueda ser modificado y adaptado a la necesidad de cada usuario, lo nico que siempre se solicita en estos
; casos es de que siempre se haga referencia al autor del mismo (es decir que no se modifique la autora del lisp),
; salvo que este se modifique ampliamente.
; Si se construye un nuevo programa tomando como partes un lisp publicado,  se debera de hacer el comentario
; de que parte del nuevo programa esta basado en el autor original.|;

; Descargado desde:
; http://www.construcgeek.com

; Actualizado:
; 29 Octubre 2009

; Este comando contiene funciones descargadas desde:
; www.4d-technologies.com


(vl-load-com)

(defun c:artose()
	(setq entpl (entsel "\nSeleccione la polilinea a transformar los arcos en segmentos: "))
	
	(if (not (null entpl))
		(progn
			(setq nentpl (car entpl))
	
			(setq lseg (getreal "\nIndique la longitud que tendr cada segmento en lugar del arco: "))
			(if (not (null lseg))
				(progn
					(initget "Conservar Eliminar")
					(setq ConservarEliminar (getkword "\nDesea conservar o eliminar la polilinea original? [Conservar/Eliminar] <Conservar>: "))
	
					(PL_ArcPl2LinearPl nentpl lseg)
					(PL_mk_pl lpl 128 0)
					
					(cond
						((= ConservarEliminar "Eliminar")
							(entdel nentpl)
						)
						(t 
							(princ)
						)
					)
				)
			)
		)
	)
	(princ)
)


;; | ----------------------------------------------------------------------------
;; | PL_ArcPl2LinearPl
;; | ----------------------------------------------------------------------------
;; | Function : Reconstructs a polyline list by replacing only all arc segments
;; |            with linear segments of specified distance.
;; | Arguments:
;; |            'ename'  - Entity name of polyline
;; |            'SegLen' - Linear Segment length
;; | Returns:
;; |            A list of all points forming the polyline. This list is in UCS
;; | Updated  : June 15, 2004
;; | e-mail   : rakesh.rao@4d-technologies.com 
;; | Web      : www.4d-technologies.com
;; | ----------------------------------------------------------------------------

(defun PL_ArcPl2LinearPl ( ename SegLen / vlist BlgLst nlist cnt len tmp
 param1 param2 NextPt pt Blg len1 oname )
(if #Verbose
	(princ "\nInside PL_ArcPl2LinearPl...")
)

(setq
	vlist  (PL_plist ename)
	BlgLst (PL_GetBulgeLst ename)
	nlist  (list (car vlist))
	cnt    0
	len    (length vlist)
	oname  (vlax-ename->vla-object ename)
)

(if #Verbose
	(princ ".")
)

(setq tmp (strcat " of " (itoa len)))
(if #Verbose
	(princ "\n")
)
(foreach pt vlist
	(setq
		Blg (nth cnt BlgLst)
		cnt (1+ cnt)
	)

	(if #Verbose
		(princ (strcat "\nProcessing vertices..." (itoa cnt) tmp))
	)

	(if (/= cnt 1)
		(setq nlist (cons pt nlist))
	)

	(if (/= cnt len)
	(progn
		(if (not (zerop Blg))
		(progn
			(setq
				NextPt (nth cnt vlist)
				param1 (vlax-curve-getParamAtPoint oname pt)
				len1   (vlax-curve-getDistAtParam oname param1)
				len1   (+ len1 SegLen)
				param1 (vlax-curve-getParamAtDist oname len1)
				param2 (vlax-curve-getParamAtPoint oname NextPt)
			)

			(if (not param1)
				(setq param1 param2)
			)

			(while (< param1 param2)
				(setq
					pt     (vlax-curve-getPointAtParam oname param1)
					nlist  (cons pt nlist)
					len1   (+ len1 SegLen)
					param1 (vlax-curve-getParamAtDist oname len1)
				)
				(if (not param1)
					(setq param1 param2)
				)
			)
		))
	))
)
(princ "..listo")
(vlax-release-object oname)
(setq lpl (reverse nlist))
)


;; | ----------------------------------------------------------------------------
;; | PL_plist
;; | ----------------------------------------------------------------------------
;; | Function : Return list of points from an LWPOLYLINE or POLYLINE
;; | Arguments:
;; |            'ename'  - The entity name of the polyline, line, 3dface or
;; |                       spline. In case of a SPLINE, the fit points are
;; |                       returned.
;; | Action   : Returns a list of all fit points of the polyline
;; |            Does not return the control points of spline polylines
;; |            or SPLINE objects.
;; | Returns  : List of all points (3D format)
;; | Updated  : Septemer 22, 1998
;; | e-mail   : rakesh.rao@4d-technologies.com 
;; | Web      : www.4d-technologies.com
;; | ----------------------------------------------------------------------------


(defun PL_plist ( ename / en entl flag vlist pt Elev sa ea Rad CenPt )

(setq
	vlist '()
	entl   (entget ename)
	en     (LI_item 0 entl)
)
(cond
	((= en "LWPOLYLINE")
		(setq
			vlist '()
			Elev   (LI_item 38 entl)
		)
		(foreach pt entl
			(if (= (car pt) 10)
				(setq vlist (cons (list (cadr pt) (caddr pt) Elev) vlist))
			)
		)
		(setq vlist (reverse vlist))
	)
	((= en "SPLINE")
		(setq vlist (LI_mitem 11 entl))
		(if (not vlist)
			(setq vlist (LI_mitem 10 entl))
			(setq vlist (reverse vlist))
		)
	)
	((= en "POLYLINE")
		(setq
			ename  (entnext ename)
			entl   (entget ename)
			en     (LI_item 0 entl)
			vlist '()
		)
		(while (= en "VERTEX")
			(setq flag (LI_item 70 entl))
			(if	(and
					(zerop (logand flag 1))
					(zerop (logand flag 2))
					(zerop (logand flag 8))
					(/= flag 128)
				)
				(setq
					pt (LI_item 10 entl)
					vlist (cons pt vlist)
				)
			)
			(setq
				ename (entnext ename)
				entl  (entget ename)
				en    (LI_item 0 entl)
			)
		)
		(setq vlist (reverse vlist))
	)
	((= en "LINE")
		(setq vlist (list (LI_item 10 entl) (LI_item 11 entl)))
	)
	((= en "ARC")
		(setq
			CenPt (LI_item 10 entl)
			sa    (LI_item 50 entl)
			ea    (LI_item 51 entl)
			Rad   (LI_item 40 entl)
			vlist (list (polar CenPt sa Rad) (polar CenPt ea Rad))
		)
	)
	((= en "3DFACE")
		(setq vlist (list
						(LI_item 10 entl) (LI_item 11 entl)
						(LI_item 12 entl) (LI_item 13 entl)
					)
		)
	)
)
vlist
)

;; | ----------------------------------------------------------------------------
;; | PL_GetBulgeLst
;; | ----------------------------------------------------------------------------
;; | Function : Returns the bulge list of an arced polyline
;; | Argument : 'ename' - Polyline object name
;; | Returns  : The list of all bulge values at each vertex
;; | Updated  : September 16, 2008
;; | e-mail   : rakesh.rao@4d-technologies.com 
;; | Web      : www.4d-technologies.com
;; | ----------------------------------------------------------------------------


(defun PL_GetBulgeLst( ename / flag en entl VxEntl BlgLst Blg )

(setq
	BlgLst '()
	entl (entget ename)
	en (LI_item 0 entl)
)
(cond
	((= en "POLYLINE")
		(setq VxEntl (cdr (PL_GetVxEntl ename)))
		(foreach entl VxEntl
			(setq flag (LI_item 70 entl))
			(if (and (zerop (logand flag 1)) (zerop (logand flag 2)) (zerop (logand flag 8)))
			(progn
				(setq Blg (LI_item 42 entl))
				(if (not Blg)
					(setq Blg 0.0)
				)
				(setq BlgLst (cons Blg BlgLst))
			))
		)
		(setq BlgLst (reverse BlgLst))
	)
	((= en "LWPOLYLINE")
		(setq BlgLst (LI_mitem 42 entl))
	)
)
BlgLst
)


;; | ---------------------------------------------------------------------------
;; | LI_item
;; | ---------------------------------------------------------------------------
;; | Function : Returns the first occurence of a DXF dotted pair from a list
;; | Argument : 'n'     - The DXF code to check
;; |            'alist' - The List to check
;; | Returns  : The value of the DXF dotted pair, if it exists else returns nil
;; | Update   : December 26, 1998
;; | e-mail   : rakesh.rao@4d-technologies.com 
;; | Web      : www.4d-technologies.com
;; | ---------------------------------------------------------------------------


(defun LI_item (n alist)

	(cdr (assoc n alist))
)

;; | ---------------------------------------------------------------------------
;; | LI_mitem
;; | ---------------------------------------------------------------------------
;; | Function : Return Multiple instances of a DXF code dotted pair from the
;; |            entity list.
;; | Argument : 'Code'   - The DXF Code to check
;; |            'alist'  - The List to check
;; | Returns  : A list of all DXF dotted pair values, if it exists else ret. nil
;; | Update   : December 26, 1998
;; | e-mail   : rakesh.rao@4d-technologies.com 
;; | Web      : www.4d-technologies.com
;; | ---------------------------------------------------------------------------


(defun LI_mitem( Code entl / Lst itm )

(setq Lst '())
(foreach itm entl
	(if (= (car itm) Code)
		(setq Lst (cons (cdr itm) Lst))
	)
)
(if Lst (reverse Lst) nil)
)


;; | --------------------------------------------------------------------------------------
;; | PL_mk_pl
;; | --------------------------------------------------------------------------------------
;; | Function : Given a list, draw a POLYLINE or LWPOLYLINE using the entmake function
;; | Arguments:
;; |            'vlist'  - List of points from which to create polyline.
;; |            'flag'   - POLYLINE or LWPOLYLINE flag (DXF Code 70)
;; |            'Width'  - Width of the polyline.
;; | Action   : Creates a POLYLINE or LWPOLYLINE from the list supplied with the specified
;; |            flag and Width.
;; |            If the flag has an '8' bit in it, a POLYLINE object is created else
;; |            if the '8' bit is absent, a POLYLINE or LWPOLYLINE object is created
;; |            depending on whether the PLINETYPE variable is 0 or 1 respectively.
;; | Updated  : March 24, 1998
;; | e-mail   : rakesh.rao@4d-technologies.com 
;; | Web      : www.4d-technologies.com
;; | --------------------------------------------------------------------------------------



(defun PL_mk_pl(vlist flag Width / Elev VFlag pt entl LWPoly Lst len)

(if (not (zerop (logand flag 8)))
(setq
	Elev 0.0 Width 0.0
	LWPoly nil
)
(progn
	(if (member (getvar "PLINETYPE") (list 1 2))
		(setq LWPoly T)
		(setq LWPoly nil)
	)
	(setq Elev (caddr (nth 0 vlist)))
))

(if LWPoly
(progn
	(setq Lst '())
	(foreach pt vlist
		(setq
			Lst (cons (list 10 (car pt) (cadr pt)) Lst)
			Lst (cons (cons 40 Width) Lst)
			Lst (cons (cons 41 Width) Lst)
		)
	)
	(setq
		len (length vlist)
		Lst (reverse Lst)
		Lst (cons (cons 38 Elev) Lst)
		Lst (cons (cons 70 flag) Lst)
		Lst (cons (cons 90 len) Lst)
		Lst (cons (cons 100 "AcDbPolyline") Lst)
		Lst (cons (cons 100 "AcDbEntity") Lst)
		Lst (cons (cons 0 "LWPOLYLINE") Lst)
	)
	(entmake Lst)
)
(progn
	(setq entl (list
					(cons 0 "POLYLINE")
					(cons 66 1)
					(list 10 0.0 0.0 Elev)
					(cons 40 Width)
					(cons 41 Width)
					(cons 70 flag)
				)
	)
	(entmake entl)

	(setq VFlag 0)
	(if (not (zerop (logand flag 8)))
		(setq VFlag (+ VFlag 32))
	)

	(if (not (zerop (logand flag 32)))
		(setq VFlag (+ VFlag 64))
	)

	(if (not (zerop (logand flag 64)))
		(setq VFlag (+ VFlag 128))
	)

	(foreach pt vlist
		(if (not (zerop (logand flag 8)))
			(setq Elev (caddr pt))
		)
		(setq entl (list
						(cons 0 "VERTEX")
						(list 10 (car pt) (cadr pt) (caddr pt))
						(cons 70 VFlag)
					)
		)
		(entmake entl)
	)
	(entmake (list (cons 0 "SEQEND")))
))
(entlast)
)



