(princ "\nEjecuta la aplicacion con la oreden:  REJI")
(defun c:reji(/ conj_puntos conj_puntos_interior_poly var_pdmode var_pdsize contorno nombre_contorno lista_contorno
	     obj_contorno dist_rejilla long_cruz long_cruz/2 num_elementos n sublista punto_n esquinas esquinas_max
	     esquinas_min X_Maxima Y_Maxima X_Minima Y_Minima x_min_cruz y_min_cruz x_max_cruz y_max_cruz x_punto
	     y_punto num_elem_conj_puntos conj_puntos_interior_poly num_puntos_int_poly nombre_punto)
  (setq conj_puntos nil)
  (setq conj_puntos_interior_poly nil)
  (setq lista_puntos_polilinea nil)
  (setq conj_puntos (ssadd))
  (setq var_pdmode (getvar "pdmode"))
  (setq var_pdsize (getvar "pdsize"))
  (setvar "pdmode" 2)
  (vl-load-com)
 
  (setq contorno (entsel"\nSelecciona la LwPolyline que define el contorno: "))
  (setq nombre_contorno (car contorno));nombre de la Polyline
  (setq lista_contorno (entget nombre_contorno))
  (while (or
	   (/= (cdr (assoc 0 lista_contorno)) "LWPOLYLINE")
	   (and (/= (cdr (assoc 70 lista_contorno)) 1) (/= (cdr (assoc 70 lista_contorno)) 129))
	 )
    (princ "\nDebes seleccionar una LwPolyline cerrada")
    (setq contorno (entsel"\nSelecciona la LwPolyline que define el contorno: "))
    (setq nombre_contorno (car contorno));nombre de la Polyline
    (setq lista_contorno (entget nombre_contorno))
  )
  (setq obj_contorno (vlax-ename->vla-object nombre_contorno));Crea objeto VLA

  (initget 7)
  (setq dist_rejilla (getint "\nDistancia entre cruces: "))
  (initget 7)
  (setq long_cruz (getreal "\nLongitud de la cruz: "))
  (setq long_cruz/2 (/ long_cruz 2))
  (setvar "pdsize" long_cruz/2)

  ;creamos lista de puntos de la LwPolyline
  (setq num_elementos (length lista_contorno))
  (setq n 0)
  (repeat num_elementos
    (setq sublista (nth n lista_contorno))
    
    (if (= (nth 0 sublista) 10)
      (progn
	(setq punto_n (cdr sublista))
	(setq lista_puntos_polilinea (cons punto_n lista_puntos_polilinea))
      )
    )
    (setq n (1+ n))
  )
  (setq lista_puntos_polilinea (reverse lista_puntos_polilinea))
  
  ;calculamos la X e Y maxima y minima de la LwPoly
  (setq esquinas (vla-GetBoundingBox obj_contorno 'variable_min 'variable_max))
  (setq esquinas_max(vlax-safearray->list variable_max))
  (setq esquinas_min(vlax-safearray->list variable_min))
  (setq X_Maxima (car esquinas_max))
  (setq Y_Maxima (cadr esquinas_max))
  (setq X_Minima (car esquinas_min))
  (setq Y_Minima (cadr esquinas_min))

  ;calculamos la X e Y maxima y minima de la rejilla
  (if (= (rem X_Minima dist_rejilla) 0)
    (setq x_min_cruz X_Minima)
    (setq x_min_cruz (+ (* (fix (/ X_Minima dist_rejilla)) dist_rejilla) dist_rejilla))
  )
  (if (= (rem Y_Minima dist_rejilla) 0)
    (setq y_min_cruz Y_Minima)
    (setq y_min_cruz (+ (* (fix (/ Y_Minima dist_rejilla)) dist_rejilla) dist_rejilla))
  )
  (if (= (rem X_Maxima dist_rejilla) 0)
    (setq x_max_cruz X_Maxima)
    (setq x_max_cruz (* (fix (/ X_Maxima dist_rejilla)) dist_rejilla))
  )
  (if (= (rem Y_Maxima dist_rejilla) 0)
    (setq y_max_cruz Y_Maxima)
    (setq y_max_cruz (* (fix (/ Y_Maxima dist_rejilla)) dist_rejilla))
  )

  (setq x_punto x_min_cruz)
  (setq y_punto y_min_cruz)
  
  (repeat (1+(/ (- y_max_cruz y_min_cruz) dist_rejilla))
    (while (<= x_punto x_max_cruz)
      (entmake (list
		   '(0 . "POINT")	
		   '(100 . "AcDbEntity") 
		   '(100 . "AcDbPoint")	
		   (cons 10 (list x_punto y_punto))
		   '(62 . 250)
	       )
      )
      (ssadd (entlast) conj_puntos)
      (setq x_punto (+ x_punto dist_rejilla ))
    )
    (setq x_punto x_min_cruz)
    (setq y_punto (+ y_punto dist_rejilla))
  )
  (setq num_elem_conj_puntos (sslength conj_puntos))

  (setq conj_puntos_interior_poly (ssget "_WP" lista_puntos_polilinea '((0 . "POINT") (62 . 250))))
  (setq num_puntos_int_poly (sslength conj_puntos_interior_poly))
  (setq n 0)
  (repeat num_puntos_int_poly
    (setq nombre_punto (ssname conj_puntos_interior_poly n))
    (setq punto_n (cdr (assoc 10 (entget nombre_punto))))
    (entmake (list
	       '(0 . "LINE")	
	       '(100 . "AcDbEntity")
	       '(100 . "AcDbLine")	
	       (cons 10 (polar punto_n (/ pi 2) long_cruz/2))
	       (cons 11 (polar punto_n (* 3 (/ pi 2)) long_cruz/2))
	     )
    );fin ENTMAKE
    (entmake (list
	       '(0 . "LINE")	
	       '(100 . "AcDbEntity") 
	       '(100 . "AcDbLine")	
	       (cons 10 (polar punto_n pi long_cruz/2))
	       (cons 11 (polar punto_n 0 long_cruz/2))
	     )
    );fin ENTMAKE
    (setq n (1+ n))
  )

  (command "_erase" conj_puntos "")
  (setvar "pdmode" var_pdmode)
  (setvar "pdsize" var_pdsize)
);fin DEFUN

  