;;;   _REN_PRES_DCL_V02.LSP 
;;;----------------------------------------------------------------------------- 
;;;   Rutina para renombrar presentaciones de forma automtica 
;;;   (se utilizan para ello las extensiones ActiveX) 
;;; 
;;;   Fecha de creacin:    18/04/2008 
;;;   Ultima modificacin:    07/02/2011    ---------- v02 ---------- (Se le aade el DCL y todos los controles necesarios) 
;;;   para llamar a la orden teclee: ren 
;;; 
(VL-LOAD-COM) 
(princ "\nEjecuta la aplicacion con la oreden:  REN")
(defun c:ren (/ ind tmp) 
(new_dialog "renombra_pr" (setq ind (load_dialog (setq tmp (crea_dcl_ren))))) 
(start_list "for") 
(mapcar 'add_list '("01" "1" "001")) 
(end_list) 
(set_tile "ini" "1") 
(action_tile "ini" "(comprobar_dato_ren)") 
(action_tile "accept" "(if (= *errores_ren* nil) (renombrar_pre))") 
(start_dialog) 
(unload_dialog ind) 
  (vl-file-delete tmp) 
) 
;------------------------------------------------------------------------------------------------- 
(defun comprobar_dato_ren (/ val) 
  (setq val (get_tile "ini"));(alert val) 
  (if (or (/= (type (read val)) 'INT) 
      (minusp (read val))) 
    (progn 
      (setq *errores_ren* T) 
      (set_tile   "error" "Ha de introducir un numero Entero positivo") 
      (mode_tile "ini" 2) 
      ) 
    (progn 
      (setq *errores_ren* nil) 
      (set_tile   "error" "") 
      (mode_tile "ini" 0) 
    ) 
  ) 
 )
;------------------------------------------------------------------------------------------------- 
(defun capturadatos_ren (/ ) 
  (setq *formato* (get_tile "for") 
   *perfijo* (get_tile "pre") 
   *sufijo* (get_tile "su") 
   *inicio* (get_tile "ini")) 
  (done_dialog 1) 
 ) 
;------------------------------------------------------------------------------------------------- 
(defun renombrar_pre (/ ) 
  (capturadatos_ren) 
  (setq pres (vla-get-Layouts (vla-get-ActiveDocument (vlax-get-acad-object)))) 
    (vlax-for x pres ;Iteramos a travs de la coleccin de presentaciones 
      (cambianombre_ren x (vla-get-TabOrder x)) 
    ) 
 (setq *formato* nil; limpiamos la memoria 
       *perfijo* nil 
       *sufijo*   nil 
       *inicio*   nil 
       ) 
) 
;------------------------------------------------------------------------------------------------- 
(defun cambianombre_ren (presentacion num /) 
  (if (= (vla-get-name presentacion) "Model") 
    nil 
    (vla-put-name presentacion (strcat *perfijo* (aade_ceros (+inicio num)) *sufijo*)) 
    ) 
  ) 
;------------------------------------------------------------------------------------------------- 
(defun +inicio (num /) 
  (if (> (read *inicio*) 1) 
    (+ (1- (read *inicio*)) num) 
    num 
    ) 
  ) 
;------------------------------------------------------------------------------------------------- 
(defun aade_ceros (n /) 
  (cond   ((= *formato* "0") 
    (cond ((<= n 9) (strcat "0" (itoa n))) 
          ((> n 9) (itoa n)) 
          ) 
    ) 
   ((= *formato* "1") (itoa n)) 
   ((= *formato* "2") 
    (cond ((<= n 9) (strcat "00" (itoa n))) 
          ((and (> n 9) (<= n 99)) (strcat "0" (itoa n))) 
          ((> n 99) (itoa n)) 
          ) 
    ) 
   ) 
  ) 
;------------------------------------------------------------------------------------------------- 
(defun crea_dcl_ren (/ arch fich) 
(setq arch (vl-filename-mktemp "renombra_pr.dcl")) 
(setq fich (open arch "w")) 
(write-line 
"renombra_pr :dialog {label=\"Renombra Presentaciones\"; 
:row { 
:column { 
   :boxed_row {label=\"Formato numrico\"; 
         :popup_list {label=\"Formato\";key=\"for\";} 
         } 
   :boxed_column {label=\"Prefijo/Sufijo\"; 
         :edit_box {label=\"Prefijo:\";edit_width=5;edit_limit=5;key=\"pre\";}
         :edit_box {label=\"Sufijo:\";edit_width=5;edit_limit=5;key=\"su\";}
         } 
   :boxed_row {label=\"Inicio de la numeracin\"; 
         :edit_box {label=\"Iniciar desde:\";edit_width=3;edit_limit=3;key=\"ini\";} 
         } 
   }    
}//fin de row 
errtile; 
:row {  spacer; 
   ok_cancel; 
   spacer; 
   } 
}" 
fich) 
(close fich) 
arch)